"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.publish = publish;
exports.publishBundle = publishBundle;

var _fs = _interopRequireWildcard(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _build = require("./build");

var _pack = require("./pack");

var _bundle = require("../core/bundle");

var _axios = require("../utils/axios");

var _formData = _interopRequireDefault(require("form-data"));

var _helpers = require("../utils/helpers");

var _repository = require("../core/repository");

var _constant = require("../constant/constant");

var _config = require("../utils/config");

var _inquirer = require("inquirer");

var _login = require("../core/login");

var _config2 = _interopRequireDefault(require("../config.json"));

var _crypto = _interopRequireDefault(require("../core/crypto"));

var _i18n = _interopRequireWildcard(require("../i18n"));

var _log = _interopRequireDefault(require("../core/log"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function publish(_x) {
  return _publish.apply(this, arguments);
}

function _publish() {
  _publish = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref) {
    var mode, old, bundle, repo, prePublishCmd, inputJson, cookie, afterPublishCmd;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            mode = _ref.mode, old = _ref.old;
            bundle = null;
            _context.prev = 2;
            bundle = _bundle.Bundle.from(process.cwd());
            repo = new _repository.Repository(_path["default"].join(process.cwd(), _constant.DEP_FOLDER_NAME), (0, _config.getGlobalRepo)());
            prePublishCmd = bundle.scripts('pre_publish');

            if (prePublishCmd) {
              (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
                return spawnSync(prePublishCmd, {
                  shell: process.env.shellPath,
                  env: bundle.vars.env,
                  cwd: bundle.path,
                  stdio: "inherit"
                });
              });
            }

            inputJson = {};

            if (!(mode === _login.LoginType.tty)) {
              _context.next = 19;
              break;
            }

            if (process.stdout.isTTY) {
              _context.next = 13;
              break;
            }

            _i18n["default"].log("publish.isNotTTY");

            _i18n["default"].log("publish.windowsCmd");

            return _context.abrupt("return", 0);

          case 13:
            _context.next = 15;
            return (0, _inquirer.prompt)([{
              type: "input",
              name: "user",
              message: "user name"
            }, {
              type: "password",
              name: "pwd",
              message: "password",
              mask: "*"
            }]);

          case 15:
            inputJson = _context.sent;
            inputJson.old = true;
            _context.next = 25;
            break;

          case 19:
            _context.next = 21;
            return (0, _login.getTokenLoginCookie)();

          case 21:
            cookie = _context.sent;

            if (cookie) {
              _context.next = 24;
              break;
            }

            throw (0, _i18n.getI18nMessage)('login.noCookie');

          case 24:
            inputJson.cookie = cookie;

          case 25:
            inputJson.old = old;
            _context.next = 28;
            return publishBundle(bundle, repo, inputJson);

          case 28:
            afterPublishCmd = bundle.scripts('publish') || bundle.scripts('after_publish');

            if (afterPublishCmd) {
              (0, _helpers.runCmdWithSpawnSync)(function (spawnSync) {
                return spawnSync(afterPublishCmd, {
                  shell: process.env.shellPath,
                  env: bundle.vars.env,
                  cwd: bundle.path,
                  stdio: "inherit"
                });
              });
            }

            _context.next = 37;
            break;

          case 32:
            _context.prev = 32;
            _context.t0 = _context["catch"](2);
            (0, _login.clearCachedCookie)();

            _i18n["default"].log("publish.error", {
              error: (0, _helpers.getErrorMessage)(_context.t0)
            });

            _log["default"].debug(_context.t0);

          case 37:
            _context.prev = 37;
            removePackedBundle(bundle);
            return _context.finish(37);

          case 40:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[2, 32, 37, 40]]);
  }));
  return _publish.apply(this, arguments);
}

function publishBundle(_x2, _x3) {
  return _publishBundle.apply(this, arguments);
}

function _publishBundle() {
  _publishBundle = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(bundle, repo) {
    var inputJson,
        _args2 = arguments;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            inputJson = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : {};

            if (!bundle.isPublishAs("binary")) {
              _context2.next = 4;
              break;
            }

            _context2.next = 4;
            return buildBeforePublish(bundle, repo);

          case 4:
            _context2.next = 6;
            return packAndUpload(bundle, inputJson);

          case 6:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _publishBundle.apply(this, arguments);
}

function buildBeforePublish(_x4, _x5) {
  return _buildBeforePublish.apply(this, arguments);
}

function _buildBeforePublish() {
  _buildBeforePublish = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(bundle, repo) {
    var buildCmd;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            buildCmd = bundle.scripts("build");

            if (!buildCmd) {
              _context3.next = 4;
              break;
            }

            _context3.next = 4;
            return (0, _build.startBuild)(bundle, repo);

          case 4:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _buildBeforePublish.apply(this, arguments);
}

function packAndUpload(_x6) {
  return _packAndUpload.apply(this, arguments);
}

function _packAndUpload() {
  _packAndUpload = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(bundle) {
    var inputJson,
        _args4 = arguments;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            inputJson = _args4.length > 1 && _args4[1] !== undefined ? _args4[1] : {};
            (0, _pack.packBundle)(bundle, {
              silent: true
            });

            if (!inputJson.old) {
              _context4.next = 7;
              break;
            }

            _context4.next = 5;
            return uploadByBundles(bundle, inputJson);

          case 5:
            _context4.next = 9;
            break;

          case 7:
            _context4.next = 9;
            return uploadByContentCenter(bundle, inputJson);

          case 9:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _packAndUpload.apply(this, arguments);
}

function uploadByBundles(_x7) {
  return _uploadByBundles.apply(this, arguments);
}

function _uploadByBundles() {
  _uploadByBundles = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(bundle) {
    var inputJson,
        filePath,
        stat,
        formData,
        stream,
        headers,
        _args5 = arguments;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            inputJson = _args5.length > 1 && _args5[1] !== undefined ? _args5[1] : {};
            filePath = "".concat(bundle.id, ".tgz");
            stat = _fs["default"].statSync(filePath);

            if (!(stat.size > _config2["default"].maxUploadSize)) {
              _context5.next = 5;
              break;
            }

            throw (0, _i18n.getI18nMessage)("publish.overlimit", {
              size: Math.floor(_config2["default"].maxUploadSize / 1024 / 1024)
            });

          case 5:
            formData = new _formData["default"]({
              maxDataSize: _config2["default"].maxUploadSize
            });
            stream = _fs["default"].createReadStream(filePath);
            formData.append("file", stream);

            if (inputJson.user || inputJson.pwd) {
              formData.append("user", inputJson.user);
              formData.append("pwd", inputJson.pwd);
            }

            headers = formData.getHeaders();

            if (inputJson.cookie) {
              headers.Cookie = inputJson.cookie;
              headers.hpmCsrfToken = (0, _login.getCsrfToken)(inputJson.cookie);
            } // 上传组件


            _axios.axios.post(_helpers.URL.bundles(bundle.manifest.name), formData, {
              headers: headers,
              maxContentLength: _config2["default"].maxUploadSize
            }).then(function (res) {
              if (res && res.data && res.data.code) {
                if (res.data.code === 200) {
                  _i18n["default"].log("publish.success");
                } else if (res.data.code === 302) {
                  (0, _login.clearCachedCookie)();
                  throw (0, _i18n.getI18nMessage)("login.expired");
                } else {
                  throw (0, _i18n.getI18nMessage)("common.message", {
                    message: res.data.message
                  });
                }
              }
            }, function (error) {
              var message = (0, _helpers.getErrorMessage)(error);

              if (message) {
                _i18n["default"].log("publish.error", {
                  error: message
                });
              } else {
                _i18n["default"].log("publish.error", {
                  error: error
                });
              }
            });

          case 12:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _uploadByBundles.apply(this, arguments);
}

function uploadByContentCenter(_x8) {
  return _uploadByContentCenter.apply(this, arguments);
}

function _uploadByContentCenter() {
  _uploadByContentCenter = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(bundle) {
    var inputJson,
        filePath,
        stat,
        csrfToken,
        fileName,
        checksum,
        uploadRes,
        data,
        _data$data,
        url,
        storageKey,
        header,
        file,
        cRes,
        updateStatusHeaders,
        statusRes,
        _args6 = arguments;

    return regeneratorRuntime.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            inputJson = _args6.length > 1 && _args6[1] !== undefined ? _args6[1] : {};
            filePath = "".concat(bundle.id, ".tgz");
            stat = _fs["default"].statSync(filePath);

            if (!(stat.size > _config2["default"].maxUploadSize)) {
              _context6.next = 5;
              break;
            }

            throw (0, _i18n.getI18nMessage)("publish.overlimit", {
              size: Math.floor(_config2["default"].maxUploadSize / 1024 / 1024)
            });

          case 5:
            csrfToken = (0, _login.getCsrfToken)(inputJson.cookie);
            fileName = bundle.manifest.name;
            checksum = _crypto["default"].digest(filePath); // 获取内容中心地址

            _context6.next = 10;
            return _axios.axios.post(_helpers.URL.upload(fileName), {
              fileName: filePath,
              checksum: checksum,
              fileSize: stat.size
            }, {
              headers: {
                "Content-Type": "application/json",
                Cookie: inputJson.cookie,
                hpmCsrfToken: csrfToken
              }
            });

          case 10:
            uploadRes = _context6.sent;
            data = uploadRes && uploadRes.data;

            if (!(data && data.code)) {
              _context6.next = 39;
              break;
            }

            if (!(data.code === 200)) {
              _context6.next = 33;
              break;
            }

            _data$data = data.data, url = _data$data.url, storageKey = _data$data.storageKey, header = _data$data.header;
            file = _fs["default"].readFileSync(filePath); // 上传至内容中心

            _context6.next = 18;
            return _axios.axios.put(url, file, {
              headers: header,
              maxContentLength: _config2["default"].maxUploadSize
            });

          case 18:
            cRes = _context6.sent;

            if (!(cRes && cRes.status === 200)) {
              _context6.next = 31;
              break;
            }

            updateStatusHeaders = {};

            if (inputJson.cookie) {
              updateStatusHeaders.Cookie = inputJson.cookie;
              updateStatusHeaders.hpmCsrfToken = csrfToken;
            } // 通知registry上传成功


            _context6.next = 24;
            return _axios.axios.post(_helpers.URL.uploadStatus(fileName, storageKey), {}, {
              headers: updateStatusHeaders
            });

          case 24:
            statusRes = _context6.sent;

            if (!(statusRes && statusRes.data && statusRes.data.code)) {
              _context6.next = 31;
              break;
            }

            if (!(statusRes.data.code === 200)) {
              _context6.next = 30;
              break;
            }

            _i18n["default"].log("publish.success");

            _context6.next = 31;
            break;

          case 30:
            throw (0, _i18n.getI18nMessage)("common.message", {
              message: statusData.message
            });

          case 31:
            _context6.next = 39;
            break;

          case 33:
            if (!(data.code === 302)) {
              _context6.next = 38;
              break;
            }

            (0, _login.clearCachedCookie)();
            throw (0, _i18n.getI18nMessage)("login.expired");

          case 38:
            throw (0, _i18n.getI18nMessage)("common.message", {
              message: data.message
            });

          case 39:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6);
  }));
  return _uploadByContentCenter.apply(this, arguments);
}

function removePackedBundle(bundle) {
  if (bundle) {
    (0, _helpers.runShellCmd)(function (shell) {
      return shell.rm("-rf", "".concat(bundle.id, ".tgz"));
    });
  }
}